diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/cache.php ./wordpress-3.4/wp-includes/cache.php
*** ./wordpress-3.3.2/wp-includes/cache.php	2011-10-18 15:20:59.000000000 -0500
--- ./wordpress-3.4/wp-includes/cache.php	2012-03-02 15:57:03.000000000 -0600
***************
*** 51,57 ****
   * @see WP_Object_Cache::decr()
   *
   * @param int|string $key The cache key to increment
!  * @param int $offset The amount by which to decrement the item's value.  Default is 1.
   * @param string $group The group the key is in.
   * @return false|int False on failure, the item's new value on success.
   */
--- 51,57 ----
   * @see WP_Object_Cache::decr()
   *
   * @param int|string $key The cache key to increment
!  * @param int $offset The amount by which to decrement the item's value. Default is 1.
   * @param string $group The group the key is in.
   * @return false|int False on failure, the item's new value on success.
   */
***************
*** 103,115 ****
   * @param int|string $key What the contents in the cache are called
   * @param string $group Where the cache contents are grouped
   * @param bool $force Whether to force an update of the local cache from the persistent cache (default is false)
   * @return bool|mixed False on failure to retrieve contents or the cache
   *		contents on success
   */
! function wp_cache_get( $key, $group = '', $force = false ) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->get( $key, $group, $force );
  }
  
  /**
--- 103,116 ----
   * @param int|string $key What the contents in the cache are called
   * @param string $group Where the cache contents are grouped
   * @param bool $force Whether to force an update of the local cache from the persistent cache (default is false)
+  * @param &bool $found Whether key was found in the cache. Disambiguates a return of false, a storable value.
   * @return bool|mixed False on failure to retrieve contents or the cache
   *		contents on success
   */
! function wp_cache_get( $key, $group = '', $force = false, &$found = null ) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->get( $key, $group, $force, $found );
  }
  
  /**
***************
*** 120,126 ****
   * @see WP_Object_Cache::incr()
   *
   * @param int|string $key The cache key to increment
!  * @param int $offset The amount by which to increment the item's value.  Default is 1.
   * @param string $group The group the key is in.
   * @return false|int False on failure, the item's new value on success.
   */
--- 121,127 ----
   * @see WP_Object_Cache::incr()
   *
   * @param int|string $key The cache key to increment
!  * @param int $offset The amount by which to increment the item's value. Default is 1.
   * @param string $group The group the key is in.
   * @return false|int False on failure, the item's new value on success.
   */
***************
*** 204,210 ****
  }
  
  /**
!  * Reset internal cache keys and structures.  If the cache backend uses global blog or site IDs as part of its cache keys,
   * this function instructs the backend to reset those keys and perform any cleanup since blog or site IDs have changed since cache init.
   *
   * @since 2.6.0
--- 205,211 ----
  }
  
  /**
!  * Reset internal cache keys and structures. If the cache backend uses global blog or site IDs as part of its cache keys,
   * this function instructs the backend to reset those keys and perform any cleanup since blog or site IDs have changed since cache init.
   *
   * @since 2.6.0
***************
*** 272,278 ****
  	/**
  	 * Adds data to the cache if it doesn't already exist.
  	 *
! 	 * @uses WP_Object_Cache::get Checks to see if the cache already has data.
  	 * @uses WP_Object_Cache::set Sets the data after the checking the cache
  	 *		contents existence.
  	 *
--- 273,279 ----
  	/**
  	 * Adds data to the cache if it doesn't already exist.
  	 *
! 	 * @uses WP_Object_Cache::_exists Checks to see if the cache already has data.
  	 * @uses WP_Object_Cache::set Sets the data after the checking the cache
  	 *		contents existence.
  	 *
***************
*** 288,297 ****
  		if ( wp_suspend_cache_addition() )
  			return false;
  
! 		if ( empty ($group) )
  			$group = 'default';
  
! 		if (false !== $this->get($key, $group))
  			return false;
  
  		return $this->set($key, $data, $group, $expire);
--- 289,298 ----
  		if ( wp_suspend_cache_addition() )
  			return false;
  
! 		if ( empty( $group ) )
  			$group = 'default';
  
! 		if ( $this->_exists($key, $group) )
  			return false;
  
  		return $this->set($key, $data, $group, $expire);
***************
*** 317,328 ****
  	 * @since 3.3.0
  	 *
  	 * @param int|string $key The cache key to increment
! 	 * @param int $offset The amount by which to decrement the item's value.  Default is 1.
  	 * @param string $group The group the key is in.
  	 * @return false|int False on failure, the item's new value on success.
  	 */
  	function decr( $key, $offset = 1, $group = 'default' ) {
! 		if ( ! isset( $this->cache[ $group ][ $key ] ) )
  			return false;
  
  		if ( ! is_numeric( $this->cache[ $group ][ $key ] ) )
--- 318,329 ----
  	 * @since 3.3.0
  	 *
  	 * @param int|string $key The cache key to increment
! 	 * @param int $offset The amount by which to decrement the item's value. Default is 1.
  	 * @param string $group The group the key is in.
  	 * @return false|int False on failure, the item's new value on success.
  	 */
  	function decr( $key, $offset = 1, $group = 'default' ) {
! 		if ( ! $this->_exists( $key, $group ) )
  			return false;
  
  		if ( ! is_numeric( $this->cache[ $group ][ $key ] ) )
***************
*** 354,366 ****
  	 * @return bool False if the contents weren't deleted and true on success
  	 */
  	function delete($key, $group = 'default', $force = false) {
! 		if (empty ($group))
  			$group = 'default';
  
! 		if (!$force && false === $this->get($key, $group))
  			return false;
  
! 		unset ($this->cache[$group][$key]);
  		return true;
  	}
  
--- 355,367 ----
  	 * @return bool False if the contents weren't deleted and true on success
  	 */
  	function delete($key, $group = 'default', $force = false) {
! 		if ( empty( $group ) )
  			$group = 'default';
  
! 		if ( ! $force && ! $this->_exists( $key, $group ) )
  			return false;
  
! 		unset( $this->cache[$group][$key] );
  		return true;
  	}
  
***************
*** 394,404 ****
  	 * @return bool|mixed False on failure to retrieve contents or the cache
  	 *		contents on success
  	 */
! 	function get( $key, $group = 'default', $force = false) {
! 		if ( empty ($group) )
  			$group = 'default';
  
! 		if ( isset ($this->cache[$group][$key]) ) {
  			$this->cache_hits += 1;
  			if ( is_object($this->cache[$group][$key]) )
  				return clone $this->cache[$group][$key];
--- 395,406 ----
  	 * @return bool|mixed False on failure to retrieve contents or the cache
  	 *		contents on success
  	 */
! 	function get( $key, $group = 'default', $force = false, &$found = null ) {
! 		if ( empty( $group ) )
  			$group = 'default';
  
! 		if ( $this->_exists( $key, $group ) ) {
! 			$found = true;
  			$this->cache_hits += 1;
  			if ( is_object($this->cache[$group][$key]) )
  				return clone $this->cache[$group][$key];
***************
*** 406,411 ****
--- 408,414 ----
  				return $this->cache[$group][$key];
  		}
  
+ 		$found = false;
  		$this->cache_misses += 1;
  		return false;
  	}
***************
*** 416,427 ****
  	 * @since 3.3.0
  	 *
  	 * @param int|string $key The cache key to increment
! 	 * @param int $offset The amount by which to increment the item's value.  Default is 1.
  	 * @param string $group The group the key is in.
  	 * @return false|int False on failure, the item's new value on success.
  	 */
  	function incr( $key, $offset = 1, $group = 'default' ) {
! 		if ( ! isset( $this->cache[ $group ][ $key ] ) )
  			return false;
  
  		if ( ! is_numeric( $this->cache[ $group ][ $key ] ) )
--- 419,433 ----
  	 * @since 3.3.0
  	 *
  	 * @param int|string $key The cache key to increment
! 	 * @param int $offset The amount by which to increment the item's value. Default is 1.
  	 * @param string $group The group the key is in.
  	 * @return false|int False on failure, the item's new value on success.
  	 */
  	function incr( $key, $offset = 1, $group = 'default' ) {
! 		if ( empty( $group ) )
! 			$group = 'default';
! 
! 		if ( ! $this->_exists( $key, $group ) )
  			return false;
  
  		if ( ! is_numeric( $this->cache[ $group ][ $key ] ) )
***************
*** 450,459 ****
  	 * @return bool False if not exists, true if contents were replaced
  	 */
  	function replace($key, $data, $group = 'default', $expire = '') {
! 		if (empty ($group))
  			$group = 'default';
  
! 		if ( false === $this->get($key, $group) )
  			return false;
  
  		return $this->set($key, $data, $group, $expire);
--- 456,465 ----
  	 * @return bool False if not exists, true if contents were replaced
  	 */
  	function replace($key, $data, $group = 'default', $expire = '') {
! 		if ( empty( $group ) )
  			$group = 'default';
  
! 		if ( ! $this->_exists( $key, $group ) )
  			return false;
  
  		return $this->set($key, $data, $group, $expire);
***************
*** 493,504 ****
  	 * @return bool Always returns true
  	 */
  	function set($key, $data, $group = 'default', $expire = '') {
! 		if ( empty ($group) )
  			$group = 'default';
  
- 		if ( NULL === $data )
- 			$data = '';
- 
  		if ( is_object($data) )
  			$data = clone $data;
  
--- 499,507 ----
  	 * @return bool Always returns true
  	 */
  	function set($key, $data, $group = 'default', $expire = '') {
! 		if ( empty( $group ) )
  			$group = 'default';
  
  		if ( is_object($data) )
  			$data = clone $data;
  
***************
*** 527,532 ****
--- 530,543 ----
  	}
  
  	/**
+ 	 * Utility function to determine whether a key exists in the cache.
+ 	 * @access private
+ 	 */
+ 	protected function _exists($key, $group) {
+ 		return isset( $this->cache[$group] ) && is_array( $this->cache[$group] ) && array_key_exists( $key, $this->cache[$group] );
+ 	}
+ 
+ 	/**
  	 * Sets up object properties; PHP 5 style constructor
  	 *
  	 * @since 2.0.8
***************
*** 553,556 ****
  		return true;
  	}
  }
- ?>
--- 564,566 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/canonical.php ./wordpress-3.4/wp-includes/canonical.php
*** ./wordpress-3.3.2/wp-includes/canonical.php	2011-11-20 12:32:42.000000000 -0600
--- ./wordpress-3.4/wp-includes/canonical.php	2012-05-02 12:39:43.000000000 -0500
***************
*** 66,71 ****
--- 66,78 ----
  	if ( !isset($redirect['query']) )
  		$redirect['query'] = '';
  
+ 	if ( is_feed() && ( $id = get_query_var( 'p' ) ) ) {
+ 		if ( $redirect_url = get_post_comments_feed_link( $id, get_query_var( 'feed' ) ) ) {
+ 			$redirect['query'] = _remove_qs_args_if_not_in_url( $redirect['query'], array( 'p', 'page_id', 'attachment_id', 'pagename', 'name', 'post_type', 'feed'), $redirect_url );
+ 			$redirect['path'] = parse_url( $redirect_url, PHP_URL_PATH );
+ 		}
+ 	}
+ 
  	if ( is_singular() && 1 > $wp_query->post_count && ($id = get_query_var('p')) ) {
  
  		$vars = $wpdb->get_results( $wpdb->prepare("SELECT post_type, post_parent FROM $wpdb->posts WHERE ID = %d", $id) );
***************
*** 75,81 ****
  				$id = $vars->post_parent;
  
  			if ( $redirect_url = get_permalink($id) )
! 				$redirect['query'] = remove_query_arg(array('p', 'page_id', 'attachment_id', 'post_type'), $redirect['query']);
  		}
  	}
  
--- 82,88 ----
  				$id = $vars->post_parent;
  
  			if ( $redirect_url = get_permalink($id) )
! 				$redirect['query'] = _remove_qs_args_if_not_in_url( $redirect['query'], array( 'p', 'page_id', 'attachment_id', 'pagename', 'name', 'post_type' ), $redirect_url );
  		}
  	}
  
***************
*** 88,99 ****
  			$post_type_obj = get_post_type_object($redirect_post->post_type);
  			if ( $post_type_obj->public ) {
  				$redirect_url = get_permalink($redirect_post);
! 				$redirect['query'] = remove_query_arg(array('p', 'page_id', 'attachment_id', 'post_type'), $redirect['query']);
  			}
  		}
  
! 		if ( ! $redirect_url )
! 			$redirect_url = redirect_guess_404_permalink();
  
  	} elseif ( is_object($wp_rewrite) && $wp_rewrite->using_permalinks() ) {
  		// rewriting of old ?p=X, ?m=2004, ?m=200401, ?m=20040101
--- 95,109 ----
  			$post_type_obj = get_post_type_object($redirect_post->post_type);
  			if ( $post_type_obj->public ) {
  				$redirect_url = get_permalink($redirect_post);
! 				$redirect['query'] = _remove_qs_args_if_not_in_url( $redirect['query'], array( 'p', 'page_id', 'attachment_id', 'pagename', 'name', 'post_type' ), $redirect_url );
  			}
  		}
  
! 		if ( ! $redirect_url ) {
! 			if ( $redirect_url = redirect_guess_404_permalink( $requested_url ) ) {
! 				$redirect['query'] = _remove_qs_args_if_not_in_url( $redirect['query'], array( 'page', 'feed', 'p', 'page_id', 'attachment_id', 'pagename', 'name', 'post_type' ), $redirect_url );
! 			}
! 		}
  
  	} elseif ( is_object($wp_rewrite) && $wp_rewrite->using_permalinks() ) {
  		// rewriting of old ?p=X, ?m=2004, ?m=200401, ?m=20040101
***************
*** 191,205 ****
  				}
  
  			}
! 		} elseif ( is_single() && strpos($wp_rewrite->permalink_structure, '%category%') !== false ) {
! 			$category = get_category_by_path(get_query_var('category_name'));
  			$post_terms = wp_get_object_terms($wp_query->get_queried_object_id(), 'category', array('fields' => 'tt_ids'));
  			if ( (!$category || is_wp_error($category)) || ( !is_wp_error($post_terms) && !empty($post_terms) && !in_array($category->term_taxonomy_id, $post_terms) ) )
  				$redirect_url = get_permalink($wp_query->get_queried_object_id());
  		}
  
  		// Post Paging
! 		if ( is_singular() && get_query_var('page') && $redirect_url ) {
  			$redirect_url = trailingslashit( $redirect_url ) . user_trailingslashit( get_query_var( 'page' ), 'single_paged' );
  			$redirect['query'] = remove_query_arg( 'page', $redirect['query'] );
  		}
--- 201,217 ----
  				}
  
  			}
! 		} elseif ( is_single() && strpos($wp_rewrite->permalink_structure, '%category%') !== false && $cat = get_query_var( 'category_name' ) ) {
! 			$category = get_category_by_path( $cat );
  			$post_terms = wp_get_object_terms($wp_query->get_queried_object_id(), 'category', array('fields' => 'tt_ids'));
  			if ( (!$category || is_wp_error($category)) || ( !is_wp_error($post_terms) && !empty($post_terms) && !in_array($category->term_taxonomy_id, $post_terms) ) )
  				$redirect_url = get_permalink($wp_query->get_queried_object_id());
  		}
  
  		// Post Paging
! 		if ( is_singular() && ! is_front_page() && get_query_var('page') ) {
! 			if ( !$redirect_url )
! 				$redirect_url = get_permalink( get_queried_object_id() );
  			$redirect_url = trailingslashit( $redirect_url ) . user_trailingslashit( get_query_var( 'page' ), 'single_paged' );
  			$redirect['query'] = remove_query_arg( 'page', $redirect['query'] );
  		}
***************
*** 216,222 ****
  			$addl_path = '';
  			if ( is_feed() && in_array( get_query_var('feed'), $wp_rewrite->feeds ) ) {
  				$addl_path = !empty( $addl_path ) ? trailingslashit($addl_path) : '';
! 				if ( get_query_var( 'withcomments' ) )
  					$addl_path .= 'comments/';
  				if ( ( 'rss' == get_default_feed() && 'feed' == get_query_var('feed') ) || 'rss' == get_query_var('feed') )
  					$addl_path .= user_trailingslashit( 'feed/' . ( ( get_default_feed() == 'rss2' ) ? '' : 'rss2' ), 'feed' );
--- 228,234 ----
  			$addl_path = '';
  			if ( is_feed() && in_array( get_query_var('feed'), $wp_rewrite->feeds ) ) {
  				$addl_path = !empty( $addl_path ) ? trailingslashit($addl_path) : '';
! 				if ( !is_singular() && get_query_var( 'withcomments' ) )
  					$addl_path .= 'comments/';
  				if ( ( 'rss' == get_default_feed() && 'feed' == get_query_var('feed') ) || 'rss' == get_query_var('feed') )
  					$addl_path .= user_trailingslashit( 'feed/' . ( ( get_default_feed() == 'rss2' ) ? '' : 'rss2' ), 'feed' );
***************
*** 265,270 ****
--- 277,291 ----
  				$redirect['path'] = trailingslashit($redirect['path']) . $addl_path;
  			$redirect_url = $redirect['scheme'] . '://' . $redirect['host'] . $redirect['path'];
  		}
+ 
+ 		if ( 'wp-register.php' == basename( $redirect['path'] ) ) {
+ 			if ( is_multisite() )
+ 				$redirect_url = apply_filters( 'wp_signup_location', site_url( 'wp-signup.php' ) );
+ 			else
+ 				$redirect_url = site_url( 'wp-login.php?action=register' );
+ 			wp_redirect( $redirect_url, 301 );
+ 			die();
+ 		}
  	}
  
  	// tack on any additional query vars
***************
*** 280,286 ****
  				unset( $_parsed_query['name'] );
  		}
  
! 		$_parsed_query = array_map( 'rawurlencode', $_parsed_query );
  		$redirect_url = add_query_arg( $_parsed_query, $redirect_url );
  	}
  
--- 301,307 ----
  				unset( $_parsed_query['name'] );
  		}
  
! 		$_parsed_query = rawurlencode_deep( $_parsed_query );
  		$redirect_url = add_query_arg( $_parsed_query, $redirect_url );
  	}
  
***************
*** 395,401 ****
  		$requested_url = preg_replace_callback('|%[a-fA-F0-9][a-fA-F0-9]|', 'lowercase_octets', $requested_url);
  	}
  
! 	// Note that you can use the "redirect_canonical" filter to cancel a canonical redirect for whatever reason by returning FALSE
  	$redirect_url = apply_filters('redirect_canonical', $redirect_url, $requested_url);
  
  	if ( !$redirect_url || $redirect_url == $requested_url ) // yes, again -- in case the filter aborted the request
--- 416,422 ----
  		$requested_url = preg_replace_callback('|%[a-fA-F0-9][a-fA-F0-9]|', 'lowercase_octets', $requested_url);
  	}
  
! 	// Note that you can use the "redirect_canonical" filter to cancel a canonical redirect for whatever reason by returning false
  	$redirect_url = apply_filters('redirect_canonical', $redirect_url, $requested_url);
  
  	if ( !$redirect_url || $redirect_url == $requested_url ) // yes, again -- in case the filter aborted the request
***************
*** 417,454 ****
  }
  
  /**
!  * Attempts to guess correct post based on query vars.
   *
   * @since 2.3.0
   * @uses $wpdb
   *
!  * @return bool|string Returns False, if it can't find post, returns correct
!  *		location on success.
   */
! function redirect_guess_404_permalink() {
! 	global $wpdb;
  
! 	if ( !get_query_var('name') )
! 		return false;
  
! 	$where = $wpdb->prepare("post_name LIKE %s", like_escape( get_query_var('name') ) . '%');
  
! 	// if any of post_type, year, monthnum, or day are set, use them to refine the query
! 	if ( get_query_var('post_type') )
! 		$where .= $wpdb->prepare(" AND post_type = %s", get_query_var('post_type'));
! 	if ( get_query_var('year') )
! 		$where .= $wpdb->prepare(" AND YEAR(post_date) = %d", get_query_var('year'));
! 	if ( get_query_var('monthnum') )
! 		$where .= $wpdb->prepare(" AND MONTH(post_date) = %d", get_query_var('monthnum'));
! 	if ( get_query_var('day') )
! 		$where .= $wpdb->prepare(" AND DAYOFMONTH(post_date) = %d", get_query_var('day'));
  
! 	$post_id = $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE $where AND post_status = 'publish'");
! 	if ( !$post_id )
! 		return false;
! 	return get_permalink($post_id);
  }
  
  add_action('template_redirect', 'redirect_canonical');
  
! ?>
--- 438,549 ----
  }
  
  /**
!  * Removes arguments from a query string if they are not present in a URL
!  * DO NOT use this in plugin code.
!  *
!  * @since 3.4
!  * @access private
!  *
!  * @return string The altered query string
!  */
! function _remove_qs_args_if_not_in_url( $query_string, Array $args_to_check, $url ) {
! 	$parsed_url = @parse_url( $url );
! 	if ( ! empty( $parsed_url['query'] ) ) {
! 		parse_str( $parsed_url['query'], $parsed_query );
! 		foreach ( $args_to_check as $qv ) {
! 			if ( !isset( $parsed_query[$qv] ) )
! 				$query_string = remove_query_arg( $qv, $query_string );
! 		}
! 	} else {
! 		$query_string = remove_query_arg( $args_to_check, $query_string );
! 	}
! 	return $query_string;
! }
! 
! /**
!  * Attempts to guess the correct URL from the current URL (that produced a 404) or
!  * the current query variables.
   *
   * @since 2.3.0
   * @uses $wpdb
   *
!  * @param string $current_url Optional. The URL that has 404'd.
!  * @return bool|string The correct URL if one is found. False on failure.
   */
! function redirect_guess_404_permalink( $current_url = '' ) {
! 	global $wpdb, $wp_rewrite;
  
! 	if ( ! empty( $current_url ) )
! 		$parsed_url = @parse_url( $current_url );
  
! 	// Attempt to redirect bare category slugs if the permalink structure starts
! 	// with the %category% tag.
! 	if ( isset( $parsed_url['path'] )
! 		&& preg_match( '#^[^%]+%category%#', $wp_rewrite->permalink_structure )
! 		&& $cat = get_category_by_path( $parsed_url['path'] )
! 	) {
! 		if ( ! is_wp_error( $cat ) )
! 			return get_term_link( $cat );
! 	}
  
! 	if ( get_query_var('name') ) {
! 		$where = $wpdb->prepare("post_name LIKE %s", like_escape( get_query_var('name') ) . '%');
  
! 		// if any of post_type, year, monthnum, or day are set, use them to refine the query
! 		if ( get_query_var('post_type') )
! 			$where .= $wpdb->prepare(" AND post_type = %s", get_query_var('post_type'));
! 		else
! 			$where .= " AND post_type IN ('" . implode( "', '", get_post_types( array( 'public' => true ) ) ) . "')";
! 
! 		if ( get_query_var('year') )
! 			$where .= $wpdb->prepare(" AND YEAR(post_date) = %d", get_query_var('year'));
! 		if ( get_query_var('monthnum') )
! 			$where .= $wpdb->prepare(" AND MONTH(post_date) = %d", get_query_var('monthnum'));
! 		if ( get_query_var('day') )
! 			$where .= $wpdb->prepare(" AND DAYOFMONTH(post_date) = %d", get_query_var('day'));
! 
! 		$post_id = $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE $where AND post_status = 'publish'");
! 		if ( ! $post_id )
! 			return false;
! 		if ( get_query_var( 'feed' ) )
! 			return get_post_comments_feed_link( $post_id, get_query_var( 'feed' ) );
! 		elseif ( get_query_var( 'page' ) )
! 			return trailingslashit( get_permalink( $post_id ) ) . user_trailingslashit( get_query_var( 'page' ), 'single_paged' );
! 		else
! 			return get_permalink( $post_id );
! 	}
! 
! 	return false;
  }
  
  add_action('template_redirect', 'redirect_canonical');
  
! function wp_redirect_admin_locations() {
! 	global $wp_rewrite;
! 	if ( ! ( is_404() && $wp_rewrite->using_permalinks() ) )
! 		return;
! 
! 	$admins = array(
! 		home_url( 'wp-admin', 'relative' ),
! 		home_url( 'dashboard', 'relative' ),
! 		home_url( 'admin', 'relative' ),
! 		site_url( 'dashboard', 'relative' ),
! 		site_url( 'admin', 'relative' ),
! 	);
! 	if ( in_array( untrailingslashit( $_SERVER['REQUEST_URI'] ), $admins ) ) {
! 		wp_redirect( admin_url() );
! 		exit;
! 	}
! 
! 	$logins = array(
! 		home_url( 'wp-login.php', 'relative' ),
! 		home_url( 'login', 'relative' ),
! 		site_url( 'login', 'relative' ),
! 	);
! 	if ( in_array( untrailingslashit( $_SERVER['REQUEST_URI'] ), $logins ) ) {
! 		wp_redirect( site_url( 'wp-login.php', 'login' ) );
! 		exit;
! 	}
! }
! 
! add_action( 'template_redirect', 'wp_redirect_admin_locations', 1000 );
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/capabilities.php ./wordpress-3.4/wp-includes/capabilities.php
*** ./wordpress-3.3.2/wp-includes/capabilities.php	2012-04-17 18:13:20.000000000 -0500
--- ./wordpress-3.4/wp-includes/capabilities.php	2012-06-12 08:50:51.000000000 -0500
***************
*** 599,604 ****
--- 599,616 ----
  	}
  
  	/**
+ 	 * Determine whether the user exists in the database.
+ 	 *
+ 	 * @since 3.4.0
+ 	 * @access public
+ 	 *
+ 	 * @return bool True if user exists in the database, false if not.
+ 	 */
+ 	function exists() {
+ 		return ! empty( $this->ID );
+ 	}
+ 
+ 	/**
  	 * Retrieve the value of a property or meta key.
  	 *
  	 * Retrieves from the users and usermeta table.
***************
*** 841,853 ****
  	 *
  	 * This is useful for looking up whether the user has a specific role
  	 * assigned to the user. The second optional parameter can also be used to
! 	 * check for capabilities against a specific post.
  	 *
  	 * @since 2.0.0
  	 * @access public
  	 *
  	 * @param string|int $cap Capability or role name to search.
- 	 * @param int $post_id Optional. Post ID to check capability against specific post.
  	 * @return bool True, if user has capability; false, if user does not have capability.
  	 */
  	function has_cap( $cap ) {
--- 853,864 ----
  	 *
  	 * This is useful for looking up whether the user has a specific role
  	 * assigned to the user. The second optional parameter can also be used to
! 	 * check for capabilities against a specific object, such as a post or user.
  	 *
  	 * @since 2.0.0
  	 * @access public
  	 *
  	 * @param string|int $cap Capability or role name to search.
  	 * @return bool True, if user has capability; false, if user does not have capability.
  	 */
  	function has_cap( $cap ) {
***************
*** 1065,1071 ****
  			break;
  		}
  
! 		if ( 'private' != $post->post_status ) {
  			$caps[] = $post_type->cap->read;
  			break;
  		}
--- 1076,1083 ----
  			break;
  		}
  
! 		$status_obj = get_post_status_object( $post->post_status );
! 		if ( $status_obj->public ) {
  			$caps[] = $post_type->cap->read;
  			break;
  		}
***************
*** 1079,1086 ****
  
  		if ( is_object( $post_author_data ) && $user_id == $post_author_data->ID )
  			$caps[] = $post_type->cap->read;
! 		else
  			$caps[] = $post_type->cap->read_private_posts;
  		break;
  	case 'edit_post_meta':
  	case 'delete_post_meta':
--- 1091,1100 ----
  
  		if ( is_object( $post_author_data ) && $user_id == $post_author_data->ID )
  			$caps[] = $post_type->cap->read;
! 		elseif ( $status_obj->private )
  			$caps[] = $post_type->cap->read_private_posts;
+ 		else
+ 			$caps = map_meta_cap( 'edit_post', $user_id, $post->ID );
  		break;
  	case 'edit_post_meta':
  	case 'delete_post_meta':
***************
*** 1112,1117 ****
--- 1126,1138 ----
  		else
  			$caps[] = 'do_not_allow';
  		break;
+ 	case 'unfiltered_html' :
+ 		// Disallow unfiltered_html for all users, even admins and super admins.
+ 		if ( defined( 'DISALLOW_UNFILTERED_HTML' ) && DISALLOW_UNFILTERED_HTML )
+ 			$caps[] = 'do_not_allow';
+ 		else
+ 			$caps[] = $cap;
+ 		break;
  	case 'edit_files':
  	case 'edit_plugins':
  	case 'edit_themes':
***************
*** 1134,1146 ****
  			break;
  		}
  		// Fall through if not DISALLOW_FILE_MODS.
- 	case 'unfiltered_html':
- 		// Disallow unfiltered_html for all users, even admins and super admins.
- 		if ( defined('DISALLOW_UNFILTERED_HTML') && DISALLOW_UNFILTERED_HTML ) {
- 			$caps[] = 'do_not_allow';
- 			break;
- 		}
- 		// Fall through if not DISALLOW_UNFILTERED_HTML
  	case 'delete_user':
  	case 'delete_users':
  		// If multisite these caps are allowed only for super admins.
--- 1155,1160 ----
***************
*** 1213,1219 ****
  	// Create new object to avoid stomping the global current_user.
  	$user = new WP_User( $current_user->ID) ;
  
! 	// Set the blog id.  @todo add blog id arg to WP_User constructor?
  	$user->for_blog( $blog_id );
  
  	$args = array_slice( func_get_args(), 2 );
--- 1227,1233 ----
  	// Create new object to avoid stomping the global current_user.
  	$user = new WP_User( $current_user->ID) ;
  
! 	// Set the blog id. @todo add blog id arg to WP_User constructor?
  	$user->for_blog( $blog_id );
  
  	$args = array_slice( func_get_args(), 2 );
***************
*** 1259,1265 ****
  	if ( ! is_object( $user ) )
  		$user = new WP_User( $user );
  
! 	if ( ! $user || ! $user->ID )
  		return false;
  
  	$args = array_slice( func_get_args(), 2 );
--- 1273,1279 ----
  	if ( ! is_object( $user ) )
  		$user = new WP_User( $user );
  
! 	if ( ! $user || ! $user->exists() )
  		return false;
  
  	$args = array_slice( func_get_args(), 2 );
***************
*** 1356,1362 ****
  	else
  		$user = wp_get_current_user();
  
! 	if ( empty( $user->ID ) )
  		return false;
  
  	if ( is_multisite() ) {
--- 1370,1376 ----
  	else
  		$user = wp_get_current_user();
  
! 	if ( ! $user->exists() )
  		return false;
  
  	if ( is_multisite() ) {
***************
*** 1370,1374 ****
  
  	return false;
  }
- 
- ?>
--- 1384,1386 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/category.php ./wordpress-3.4/wp-includes/category.php
*** ./wordpress-3.3.2/wp-includes/category.php	2010-11-16 18:56:00.000000000 -0600
--- ./wordpress-3.4/wp-includes/category.php	2012-01-08 11:01:11.000000000 -0600
***************
*** 207,226 ****
   * @return bool Whether $cat2 is child of $cat1
   */
  function cat_is_ancestor_of( $cat1, $cat2 ) {
! 	if ( ! isset($cat1->term_id) )
! 		$cat1 = &get_category( $cat1 );
! 	if ( ! isset($cat2->parent) )
! 		$cat2 = &get_category( $cat2 );
! 
! 	if ( empty($cat1->term_id) || empty($cat2->parent) )
! 		return false;
! 	if ( $cat2->parent == $cat1->term_id )
! 		return true;
! 
! 	return cat_is_ancestor_of( $cat1, get_category( $cat2->parent ) );
  }
  
- 
  /**
   * Sanitizes category data based on context.
   *
--- 204,212 ----
   * @return bool Whether $cat2 is child of $cat1
   */
  function cat_is_ancestor_of( $cat1, $cat2 ) {
! 	return term_is_ancestor_of( $cat1, $cat2, 'category' );
  }
  
  /**
   * Sanitizes category data based on context.
   *
***************
*** 354,359 ****
  		$category['category_parent'] = &$category['parent'];
  	}
  }
- 
- 
- ?>
--- 334,336 ----
